/*
  reflection for ikkeiplexing shield by ikkei
  http://blog.goo.ne.jp/jh3kxm
  
  History:
        2010-12-11 - V1.0 reflection skeleton ikkei
        2013-10-26 - update class library
        2018-04-04 - update library
*/

#include <MsTimer2.h>
#include <ikkeiplexing.h>

ikkeiplexing iLedSign;

const uint8_t X_MAX = 15;
const uint8_t Y_MAX = 7;

void setup(){
  iLedSign.Init(TITCHAINO, SINGLE_BUFFER);
}

void loop(){
  static int8_t x = 0;
  static uint8_t dx = 1;
  static int8_t y = 0;
  static uint8_t dy = 1;
  
  iLedSign.Set(x, y, 0); // turn off the previous dot
  x += dx;
  y += dy;
  iLedSign.Set(x, y, 1); // turn on the next dot
  
  if ((x <= 0)||(x >= X_MAX)){ // reaching the boundary of x
    dx = -dx;
  }
  if ((y <= 0)||(y >= Y_MAX)){ // reaching the boundary of y
    dy = -dy;
  }
  delay(50);
}


