/*
  Charlieplexing.h - Library for controlling the charliplexed led board
  from JimmiePRodgers.com
  Created by Alex Wenger, December 30, 2009.
  Modified by Matt Mets, May 28, 2010.
  Released into the public domain.
          2013-10-26 - update class library
*/

#ifndef ikkeiplexing_h
#define ikkeiplexing_h

#include <Arduino.h>

#define SINGLE_BUFFER 0
#define DOUBLE_BUFFER 1
#define SW_LEVEL 0
#define SW_EDGE 1
enum {IKKEIPLEXING, TITCHAINO, TITCHAINO_UNI, ONBOARD, DOTSDUINO, DOTSDUINO2D, SQUARE8};

class ikkeiplexing{
public:
    void Init(byte mode = SINGLE_BUFFER);
    void Init(byte assign, byte mode = SINGLE_BUFFER);
    void ShiftLeft();
    void ShiftRight();
    void Set(byte x, byte y, byte c);
    byte Get(byte x, byte y);
    void Flip(bool blocking = false);
    void Clear(int set=0);
    void Horizontal(int y, int set=0);
    void Vertical(int x, int set=0);
    byte GetSW(byte edge);
    byte GetPeriod(void);
 	void Vwrite(int x, byte data);
    void write(byte y, const uint16_t values[], byte size);
    void write90(byte y, const uint16_t values[], byte size);
};

#endif
